void SemaphoreRegister(SEMAPHORE *s, int start)
{
  s->header.id = CurrentProcessID;
  s->header.priority = 0;
  ListInsert(&SemaphoreList,&s->header);
  ListInitialize(&s->list,FIFOListType);
  s->count = start;
}

void SemaphoreUnregister(SEMAPHORE *s)
{
  ListRemove(&SemaphoreList,&s->header);
}

void SemaphoreWait(SEMAPHORE *s)
{
  ToggleScheduler();
  s->count--;
  if(s->count < 0) {
    // Entire resource is taken
    MoveProcess(CurrentProcessContext,&ContextList,&s->list);
  }
  else {
    // Part of resource left, just keep running
    ToggleScheduler();
  }
}

void SemaphoreSignal(SEMAPHORE *s)
{
  ToggleScheduler();
  s->count++;
  if(s->count <= 0) {
    // There are processes waiting in the semaphore list
    MoveProcess((PROCESS_CONTEXT_ENTRY *)s->list.first,&s->list,&ContextList);
  }
  ToggleScheduler();
}
