#define TI92PLUS
//#define TI89

#include <romcalls.h>
#include <prosit.h>
#include <winlib.h>
#include <wmlib.h>

int _library;

void WM_InitializeWindow(PWINDOW *w)
{
  if(w->Win.Flags.all & PWF_USES_WMLIB) {
    WIN_RECT Light = {0, 0, w->Width-1, w->Height - 1};
    WIN_RECT Dark1 = {1, 1+7*(w->Win.Title != NULL), w->Width-1, w->Height - 1};
    WIN_RECT Dark2 = {w->Width-1, 1, w->Width-1, 8};
    int border = (!w->Win.Flags.bits.noborder) << 1;
    WIN_RECT Inside = {border, border+7*(w->Win.Title != NULL), w->Width-1-border, w->Height-1-border};
    HANDLE OldPlane = w->Win.DupScr;
    int i;

/*
    w->Win.DupScr = w->ContentsHandle[0];
    WinFill(&w->Win, &Light, A_REVERSE);
    w->Win.DupScr = w->ContentsHandle[1];
    WinFill(&w->Win, &Light, A_NORMAL);
*/

    // Set the window region to what the WM has access to, and set the clip
    // region to the same temporarily so that we can draw something there :)
    w->Win.Clip = w->Win.Window = (SCR_RECT){0, 0, w->Width-1, w->Height - 1};

    // Draw some stuff.
    for(i=1 ; i>=0 ; i--) {
      w->Win.DupScr = w->ContentsHandle[i];
      WinFill(&w->Win, &Inside, i);
      if(!(w->Win.Flags.all & PWF_NOBORDER)) {
        WinRect(&w->Win, &Light, A_REVERSE+B_DOUBLE);
        WinRect(&w->Win, &Dark1, A_NORMAL);
      }
      if(w->Win.Title) {
        BYTE OldFont = w->Win.CurFont;
        BYTE OldAttr = WinAttr(&w->Win, A_NORMAL);
        WinFont(&w->Win, 0);
        WinStrXY(&w->Win, 1, 2, w->Win.Title);
        WinFont(&w->Win, OldFont);
        WinAttr(&w->Win, OldAttr);
        WinLine(&w->Win, &Dark2);
      }
    }

    // Show that the window doesn't have focus.
    if(w->Win.Title) {
      Light = (WIN_RECT){1, 1, w->Width-2, 7};
      WinFill(&w->Win, &Light, A_XOR);
    }

    // Set the client and clip areas.
    w->Win.Clip = w->Win.Client = (SCR_RECT){Inside.x0, Inside.y0, Inside.x1, Inside.y1};
//    w->Win.Clip = w->Win.Client = (SCR_RECT){2, 2+7*(w->Win.Title != NULL), w->Width-3, w->Height-3};

    w->Win.DupScr = OldPlane;

    WM_WindowGotFocus(w);
  }
}

ToggleWindowFocus(PWINDOW *w)
{
  if((w) && (w->Win.Flags.all & PWF_USES_WMLIB) && (w->Win.Title)) {
    HANDLE OldPlane = w->Win.DupScr;
    SCR_RECT OldClip = w->Win.Clip;
    WIN_RECT Light = {1, 1, w->Width-2, 7};

    // Set the clip region to the WM region so that we can draw.
    w->Win.Clip = w->Win.Window;

    // Toggle the "title bar".
    w->Win.DupScr = w->ContentsHandle[1];
    WinFill(&w->Win, &Light, A_XOR);

    PWinRefresh(w);

    // Restore what we have changed.
    w->Win.Clip = OldClip;
    w->Win.DupScr = OldPlane;
  }
}

void WM_WindowGotFocus(PWINDOW *w)
{
  if(WindowInFocus != w) {
    WM_WindowLostFocus(WindowInFocus);
    ToggleWindowFocus(w);
    WindowInFocus = w;
  }
}

void WM_WindowLostFocus(PWINDOW *w)
{
  ToggleWindowFocus(w);
}

void WM_Click(EventClickStruct *e)
//void WM_Click(PWINDOW *w, WIN_POINT xy)
{
  WM_WindowGotFocus(e->w);

  if(e->w->Win.Flags.all & (PWF_USES_WMLIB + PWF_ACTIVE)) {
    if(e->xy.y0 < 2+8*(e->w->Win.Title != NULL)) {
      int OldMouseX = MouseX, OldMouseY = MouseY;
      PWinMoveToFront(e->w);
      while(!MOUSEKEY) {
        if(e->w->Win.Flags.all & PWF_MOVEABLE) {
          if((MouseX != OldMouseX) || (MouseY != OldMouseY)) {
            OldMouseX = MouseX;
            OldMouseY = MouseY;
            PWinMoveTo(e->w, MouseX-e->xy.x0, MouseY-e->xy.y0);
          }
        }
        else {
          MouseX = OldMouseX;
          MouseY = OldMouseY;
        }
        BreakAndCooperate();
      }
    }
  }
  else {

  }
}
